diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/minstrel-wifi-manager.h ns-3.34/src/wifi/model/rate-control/minstrel-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/minstrel-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/minstrel-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,357 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2009 Duy Nguyen
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Duy Nguyen <duy@soe.ucsc.edu>
+ *          Matías Richart <mrichart@fing.edu.uy>
+ */
+
+#ifndef MINSTREL_WIFI_MANAGER_H
+#define MINSTREL_WIFI_MANAGER_H
+
+#include "ns3/traced-value.h"
+#include "ns3/wifi-remote-station-manager.h"
+#include <fstream>
+#include <map>
+
+namespace ns3 {
+
+class UniformRandomVariable;
+
+/**
+ * A struct to contain all information related to a data rate
+ */
+struct RateInfo
+{
+  /**
+   * Perfect transmission time calculation, or frame calculation
+   * Given a bit rate and a packet length n bytes
+   */
+  Time perfectTxTime;
+
+  uint32_t retryCount;          ///< retry limit
+  uint32_t adjustedRetryCount;  ///< adjust the retry limit for this rate
+  uint32_t numRateAttempt;      ///< how many number of attempts so far
+  uint32_t numRateSuccess;      ///< number of successful packets
+  uint32_t prob;                ///< (# packets success)/(# total packets)
+  /**
+   * EWMA calculation
+   * ewma_prob =[prob *(100 - ewma_level) + (ewma_prob_old * ewma_level)]/100
+   */
+  uint32_t ewmaProb;
+  uint32_t throughput;  ///< throughput of a rate in bps
+
+  uint32_t prevNumRateAttempt;  //!< Number of transmission attempts with previous rate.
+  uint32_t prevNumRateSuccess;  //!< Number of successful frames transmitted with previous rate.
+  uint64_t successHist;         //!< Aggregate of all transmission successes.
+  uint64_t attemptHist;         //!< Aggregate of all transmission attempts.
+
+  uint8_t numSamplesSkipped; //!< number of samples skipped
+  int sampleLimit; //!< sample limit
+};
+
+/**
+ * Data structure for a Minstrel Rate table
+ * A vector of a struct RateInfo
+ */
+typedef std::vector<RateInfo> MinstrelRate;
+/**
+ * Data structure for a Sample Rate table
+ * A vector of a vector uint8_t
+ */
+typedef std::vector<std::vector<uint8_t> > SampleRate;
+
+/**
+ * \brief hold per-remote-station state for Minstrel Wifi manager.
+ *
+ * This struct extends from WifiRemoteStation struct to hold additional
+ * information required by the Minstrel Wifi manager
+ */
+struct MinstrelWifiRemoteStation : public WifiRemoteStation
+{
+  Time m_nextStatsUpdate;  ///< 10 times every second
+
+  /**
+   * To keep track of the current position in the our random sample table
+   * going row by row from 1st column until the 10th column(Minstrel defines 10)
+   * then we wrap back to the row 1 column 1.
+   * note: there are many other ways to do this.
+   */
+  uint8_t m_col;                 ///< column index
+  uint8_t m_index;               ///< vector index
+  uint16_t m_maxTpRate;          ///< the current throughput rate in bps
+  uint16_t m_maxTpRate2;         ///< second highest throughput rate in bps
+  uint16_t m_maxProbRate;        ///< rate with highest probability of success in bps
+  uint8_t m_nModes;              ///< number of modes supported
+  int m_totalPacketsCount;       ///< total number of packets as of now
+  int m_samplePacketsCount;      ///< how many packets we have sample so far
+  int m_numSamplesDeferred;      ///< number samples deferred
+  bool m_isSampling;             ///< a flag to indicate we are currently sampling
+  uint16_t m_sampleRate;         ///< current sample rate in bps
+  bool m_sampleDeferred;         ///< a flag to indicate sample rate is on the second stage
+  uint32_t m_shortRetry;         ///< short retries such as control packets
+  uint32_t m_longRetry;          ///< long retries such as data packets
+  uint32_t m_retry;              ///< total retries short + long
+  uint16_t m_txrate;             ///< current transmit rate in bps
+  bool m_initialized;            ///< for initializing tables
+  MinstrelRate m_minstrelTable;  ///< minstrel table
+  SampleRate m_sampleTable;      ///< sample table
+  std::ofstream m_statsFile;     ///< stats file
+};
+
+
+/**
+ * \brief Implementation of Minstrel Rate Control Algorithm
+ * \ingroup wifi
+ *
+ * Minstrel is a rate control algorithm implemented in MadWifi and Linux.
+ * The basic principle is to probe the environment and adapt the rate
+ * based on statistics collected on the probability of successful
+ * transmission.  The algorithm adapts the rate to the highest rate
+ * that it considers successful, and spends a fraction of its time
+ * doing 'look around' by trying other rates.
+ *
+ * Minstrel is appropriate for non-HT configurations; for HT (i.e. 802.11n
+ * or higher), users should use MinstrelHtWifiManager instead.
+ * Minstrel will error exit if the user tries to configure it with a
+ * Wi-Fi MAC that supports 802.11n or higher.
+ *
+ * Some notes on this implementation follow.  The implementation has
+ * been adapted to bring it closer to the Linux implementation.
+ * For each rate, a new parameter samplesSkipped is added. This parameter
+ * is intended to solve an issue regarding the sampling of low rates when
+ * a high rate is working well, which leads to outdated statistics.
+ * This change makes throughput a bit lower in simple, stable scenarios,
+ * but may help in dynamic scenarios to react faster and more accurately
+ * to changes.
+ *
+ * Related to the previous, the logic for deciding when to sample random
+ * rates is as follows.  When a sample rate is deferred to the second MRR
+ * chain stage, a new parameter (numSamplesDeferred) is increased. This
+ * parameters is used (jointly with sampleCount) to compare current
+ * sample count with the lookaround rate.
+ *
+ * Also related with sampling, another parameter sampleLimit is added.
+ * This parameter limits the number of times a very low or very high
+ * probability rate is sampled, avoiding to try a poorly working sample
+ * rate too often.
+ *
+ * When updating the EWMA probability of a rate for the first time, it does
+ * not apply EWMA but instead assigns the entire probability.
+ * Since the EWMA probability is initialized to zero, this generates
+ * a more accurate EWMA.
+ */
+class MinstrelWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  MinstrelWifiManager ();
+  virtual ~MinstrelWifiManager ();
+
+  void SetupPhy (const Ptr<WifiPhy> phy) override;
+  void SetupMac (const Ptr<WifiMac> mac) override;
+  int64_t AssignStreams (int64_t stream) override;
+
+  /**
+   * Update the rate.
+   *
+   * \param station the station object
+   */
+  void UpdateRate (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Update the Minstrel Table.
+   *
+   * \param station the station object
+   */
+  void UpdateStats (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Find a rate to use from Minstrel Table.
+   *
+   * \param station the station object
+   * \returns the rate in bps
+   */
+  uint16_t FindRate (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Get data transmit vector.
+   *
+   * \param station the station object
+   * \returns WifiTxVector
+   */
+  WifiTxVector GetDataTxVector (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Get RTS transmit vector.
+   *
+   * \param station the station object
+   * \returns WifiTxVector
+   */
+  WifiTxVector GetRtsTxVector (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Get the number of retries.
+   *
+   * \param station the station object
+   * \returns the number of retries
+   */
+  uint32_t CountRetries (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Update packet counters.
+   *
+   * \param station the station object
+   */
+  void UpdatePacketCounters (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Update the number of retries and reset accordingly.
+   *
+   * \param station the station object
+   */
+  void UpdateRetry (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Check for initializations.
+   *
+   * \param station the station object
+   */
+  void CheckInit (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Initialize Sample Table.
+   *
+   * \param station the station object
+   */
+  void InitSampleTable (MinstrelWifiRemoteStation *station);
+
+private:
+  void DoInitialize (void) override;
+  WifiRemoteStation * DoCreateStation (void) const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+
+  bool DoNeedRetransmission (WifiRemoteStation *st,
+                                 Ptr<const Packet> packet, bool normally) override;
+
+
+  /**
+   * Estimate the TxTime of a packet with a given mode.
+   *
+   * \param mode Wi-Fi mode
+   * \returns the transmission time
+   */
+  Time GetCalcTxTime (WifiMode mode) const;
+  /**
+   * Add transmission time for the given mode to an internal list.
+   *
+   * \param mode Wi-Fi mode
+   * \param t transmission time
+   */
+  void AddCalcTxTime (WifiMode mode, Time t);
+
+  /**
+   * Initialize Minstrel Table.
+   *
+   * \param station the station object
+   */
+  void RateInit (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Get the next sample from Sample Table.
+   *
+   * \param station the station object
+   * \returns the next sample
+   */
+  uint16_t GetNextSample (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Estimate the time to transmit the given packet with the given number of retries.
+   * This function is "roughly" the function "calc_usecs_unicast_packet" in minstrel.c
+   * in the madwifi implementation.
+   *
+   * The basic idea is that, we try to estimate the "average" time used to transmit the
+   * packet for the given number of retries while also accounting for the 802.11 congestion
+   * window change. The original code in the madwifi seems to estimate the number of backoff
+   * slots as the half of the current CW size.
+   *
+   * There are four main parts:
+   *  - wait for DIFS (sense idle channel)
+   *  - Ack timeouts
+   *  - Data transmission
+   *  - backoffs according to CW
+   *
+   * \param dataTransmissionTime the data transmission time
+   * \param shortRetries short retries
+   * \param longRetries long retries
+   * \returns the unicast packet time
+   */
+  Time CalculateTimeUnicastPacket (Time dataTransmissionTime, uint32_t shortRetries, uint32_t longRetries);
+
+  /**
+   * Print Sample Table.
+   *
+   * \param station the station object
+   */
+  void PrintSampleTable (MinstrelWifiRemoteStation *station);
+
+  /**
+   * Print Minstrel Table.
+   *
+   * \param station the station object
+   */
+  void PrintTable (MinstrelWifiRemoteStation *station);
+
+  /**
+   * typedef for a vector of a pair of Time, WifiMode.
+   * Essentially a map from WifiMode to its corresponding transmission time
+   * to transmit a reference packet.
+   */
+  typedef std::map<WifiMode, Time> TxTime;
+
+  TxTime m_calcTxTime;      ///< to hold all the calculated TxTime for all modes
+  Time m_updateStats;       ///< how frequent do we calculate the stats
+  uint8_t m_lookAroundRate; ///< the % to try other rates than our current rate
+  uint8_t m_ewmaLevel;      ///< exponential weighted moving average
+  uint8_t m_sampleCol;      ///< number of sample columns
+  uint32_t m_pktLen;        ///< packet length used for calculate mode TxTime
+  bool m_printStats;        ///< whether statistics table should be printed.
+  bool m_printSamples;      ///< whether samples table should be printed.
+
+  /// Provides uniform random variables.
+  Ptr<UniformRandomVariable> m_uniformRandomVariable;
+
+  TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
+};
+
+} //namespace ns3
+
+#endif /* MINSTREL_WIFI_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/onoe-wifi-manager.cc ns-3.34/src/wifi/model/rate-control/onoe-wifi-manager.cc
--- ns-3.33/src/wifi/model/rate-control/onoe-wifi-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/onoe-wifi-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,367 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2003,2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+#include "onoe-wifi-manager.h"
+#include "ns3/wifi-tx-vector.h"
+
+#define Min(a,b) ((a < b) ? a : b)
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("OnoeWifiManager");
+
+/**
+ * \brief hold per-remote-station state for ONOE Wifi manager.
+ *
+ * This struct extends from WifiRemoteStation struct to hold additional
+ * information required by the ONOE Wifi manager
+ */
+struct OnoeWifiRemoteStation : public WifiRemoteStation
+{
+  Time m_nextModeUpdate; ///< next mode update
+  bool m_rateBlocked; ///< whether the rate cannot be changed
+  uint32_t m_shortRetry; ///< short retry
+  uint32_t m_longRetry; ///< long retry
+  uint32_t m_tx_ok; ///< transmit OK
+  uint32_t m_tx_err; ///< transmit error
+  uint32_t m_tx_retr; ///< transmit retry
+  uint32_t m_tx_upper; ///< transmit upper
+  uint8_t m_txrate; ///< transmit rate
+};
+
+NS_OBJECT_ENSURE_REGISTERED (OnoeWifiManager);
+
+TypeId
+OnoeWifiManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::OnoeWifiManager")
+    .SetParent<WifiRemoteStationManager> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<OnoeWifiManager> ()
+    .AddAttribute ("UpdatePeriod",
+                   "The interval between decisions about rate control changes",
+                   TimeValue (Seconds (1.0)),
+                   MakeTimeAccessor (&OnoeWifiManager::m_updatePeriod),
+                   MakeTimeChecker ())
+    .AddAttribute ("RaiseThreshold", "Attempt to raise the rate if we hit that threshold",
+                   UintegerValue (10),
+                   MakeUintegerAccessor (&OnoeWifiManager::m_raiseThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("AddCreditThreshold", "Add credit threshold",
+                   UintegerValue (10),
+                   MakeUintegerAccessor (&OnoeWifiManager::m_addCreditThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddTraceSource ("Rate",
+                     "Traced value for rate changes (b/s)",
+                     MakeTraceSourceAccessor (&OnoeWifiManager::m_currentRate),
+                     "ns3::TracedValueCallback::Uint64")
+  ;
+  return tid;
+}
+
+OnoeWifiManager::OnoeWifiManager ()
+  : WifiRemoteStationManager (),
+    m_currentRate (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+OnoeWifiManager::~OnoeWifiManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+OnoeWifiManager::DoInitialize ()
+{
+  NS_LOG_FUNCTION (this);
+  if (GetHtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HT rates");
+    }
+  if (GetVhtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support VHT rates");
+    }
+  if (GetHeSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HE rates");
+    }
+}
+
+WifiRemoteStation *
+OnoeWifiManager::DoCreateStation (void) const
+{
+  NS_LOG_FUNCTION (this);
+  OnoeWifiRemoteStation *station = new OnoeWifiRemoteStation ();
+  station->m_nextModeUpdate = Simulator::Now () + m_updatePeriod;
+  station->m_rateBlocked = false;
+  station->m_shortRetry = 0;
+  station->m_longRetry = 0;
+  station->m_tx_ok = 0;
+  station->m_tx_err = 0;
+  station->m_tx_retr = 0;
+  station->m_tx_upper = 0;
+  station->m_txrate = 0;
+  return station;
+}
+
+void
+OnoeWifiManager::DoReportRxOk (WifiRemoteStation *station, double rxSnr, WifiMode txMode)
+{
+  NS_LOG_FUNCTION (this << station << rxSnr << txMode);
+}
+
+void
+OnoeWifiManager::DoReportRtsFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  station->m_shortRetry++;
+  station->m_rateBlocked = true;  // do not change rate for retransmission
+}
+
+void
+OnoeWifiManager::DoReportDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  station->m_longRetry++;
+  station->m_rateBlocked = true;  // do not change rate for retransmission
+}
+
+void
+OnoeWifiManager::DoReportRtsOk (WifiRemoteStation *st, double ctsSnr, WifiMode ctsMode, double rtsSnr)
+{
+  NS_LOG_FUNCTION (this << st << ctsSnr << ctsMode << rtsSnr);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  station->m_rateBlocked = true;  // do not change rate
+}
+
+void
+OnoeWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
+{
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  UpdateRetry (station);
+  station->m_tx_ok++;
+  station->m_rateBlocked = false;  // we can change the rate for next packet
+}
+
+void
+OnoeWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  UpdateRetry (station);
+  station->m_tx_err++;
+  station->m_rateBlocked = false;  // we can change the rate for next packet
+}
+
+void
+OnoeWifiManager::DoReportFinalDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  UpdateRetry (station);
+  station->m_tx_err++;
+  station->m_rateBlocked = false;  // we can change the rate for next packet
+}
+
+void
+OnoeWifiManager::UpdateRetry (OnoeWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  station->m_tx_retr += station->m_shortRetry + station->m_longRetry;
+  station->m_shortRetry = 0;
+  station->m_longRetry = 0;
+}
+
+void
+OnoeWifiManager::UpdateMode (OnoeWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  if (Simulator::Now () < station->m_nextModeUpdate || station->m_rateBlocked)
+    {
+      return;
+    }
+  station->m_nextModeUpdate = Simulator::Now () + m_updatePeriod;
+  /**
+   * The following 20 lines of code were copied from the Onoe
+   * rate control kernel module used in the madwifi driver.
+   */
+
+  int dir = 0, enough;
+  uint8_t nrate;
+  enough = (station->m_tx_ok + station->m_tx_err >= 10);
+
+  /* no packet reached -> down */
+  if (station->m_tx_err > 0 && station->m_tx_ok == 0)
+    {
+      dir = -1;
+    }
+
+  /* all packets needs retry in average -> down */
+  if (enough && station->m_tx_ok < station->m_tx_retr)
+    {
+      dir = -1;
+    }
+
+  /* no error and less than rate_raise% of packets need retry -> up */
+  if (enough && station->m_tx_err == 0
+      && station->m_tx_retr < (station->m_tx_ok * m_addCreditThreshold) / 100)
+    {
+      dir = 1;
+    }
+
+  NS_LOG_DEBUG (this << " ok " << station->m_tx_ok << " err " << station->m_tx_err << " retr " << station->m_tx_retr <<
+                " upper " << station->m_tx_upper << " dir " << dir);
+
+  nrate = station->m_txrate;
+  switch (dir)
+    {
+    case 0:
+      if (enough && station->m_tx_upper > 0)
+        {
+          station->m_tx_upper--;
+        }
+      break;
+    case -1:
+      if (nrate > 0)
+        {
+          nrate--;
+        }
+      station->m_tx_upper = 0;
+      break;
+    case 1:
+      /* raise rate if we hit rate_raise_threshold */
+      if (++station->m_tx_upper < m_raiseThreshold)
+        {
+          break;
+        }
+      station->m_tx_upper = 0;
+      if (nrate + 1 < GetNSupported (station))
+        {
+          nrate++;
+        }
+      break;
+    }
+
+  if (nrate != station->m_txrate)
+    {
+      NS_ASSERT (nrate < GetNSupported (station));
+      station->m_txrate = nrate;
+      station->m_tx_ok = station->m_tx_err = station->m_tx_retr = station->m_tx_upper = 0;
+    }
+  else if (enough)
+    {
+      station->m_tx_ok = station->m_tx_err = station->m_tx_retr = 0;
+    }
+
+}
+
+WifiTxVector
+OnoeWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  UpdateMode (station);
+  NS_ASSERT (station->m_txrate < GetNSupported (station));
+  uint8_t rateIndex;
+  if (station->m_longRetry < 4)
+    {
+      rateIndex = station->m_txrate;
+    }
+  else if (station->m_longRetry < 6)
+    {
+      if (station->m_txrate > 0)
+        {
+          rateIndex = station->m_txrate - 1;
+        }
+      else
+        {
+          rateIndex = station->m_txrate;
+        }
+    }
+  else if (station->m_longRetry < 8)
+    {
+      if (station->m_txrate > 1)
+        {
+          rateIndex = station->m_txrate - 2;
+        }
+      else
+        {
+          rateIndex = station->m_txrate;
+        }
+    }
+  else
+    {
+      if (station->m_txrate > 2)
+        {
+          rateIndex = station->m_txrate - 3;
+        }
+      else
+        {
+          rateIndex = station->m_txrate;
+        }
+    }
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  WifiMode mode = GetSupported (station, rateIndex);
+  if (m_currentRate != mode.GetDataRate (channelWidth))
+    {
+      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
+      m_currentRate = mode.GetDataRate (channelWidth);
+    }
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+}
+
+WifiTxVector
+OnoeWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  UpdateMode (station);
+  WifiTxVector rtsTxVector;
+  WifiMode mode;
+  if (GetUseNonErpProtection () == false)
+    {
+      mode = GetSupported (station, 0);
+    }
+  else
+    {
+      mode = GetNonErpSupported (station, 0);
+    }
+  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+  return rtsTxVector;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/onoe-wifi-manager.h ns-3.34/src/wifi/model/rate-control/onoe-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/onoe-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/onoe-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,96 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2003,2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#ifndef ONOE_WIFI_MANAGER_H
+#define ONOE_WIFI_MANAGER_H
+
+#include "ns3/traced-value.h"
+#include "ns3/wifi-remote-station-manager.h"
+
+namespace ns3 {
+
+struct OnoeWifiRemoteStation;
+
+/**
+ * \brief an implementation of the rate control algorithm developed
+ *        by Atsushi Onoe
+ *
+ * \ingroup wifi
+ *
+ * This algorithm is well known because it has been used as the default
+ * rate control algorithm for the madwifi driver. I am not aware of
+ * any publication or reference about this algorithm beyond the madwifi
+ * source code.
+ *
+ * This RAA does not support HT modes and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11n or higher.
+ */
+class OnoeWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  OnoeWifiManager ();
+  virtual ~OnoeWifiManager ();
+
+
+private:
+  void DoInitialize (void) override;
+  WifiRemoteStation * DoCreateStation (void) const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+
+  /**
+   * Update the number of retry (both short and long).
+   *
+   * \param station the ONOE wifi remote station
+   */
+  void UpdateRetry (OnoeWifiRemoteStation *station);
+  /**
+   * Update the mode.
+   *
+   * \param station the ONOE wifi remote station
+   */
+  void UpdateMode (OnoeWifiRemoteStation *station);
+
+  Time m_updatePeriod; ///< update period
+  uint32_t m_addCreditThreshold; ///< add credit threshold
+  uint32_t m_raiseThreshold; ///< raise threshold
+
+  TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
+};
+
+} //namespace ns3
+
+#endif /* ONOE_WIFI_MANAGER_H */
